import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * En esta clase se generan los escenarios,en los cuales se crean los objetos
 * que apareceran en los niveles, y en la precentacion, aqui se hacen el cambio 
 * de escenario como el de ganar perder, se pone la imagen de las vidas.
 * @author (your name) 
 * @version (a version number or a date)
 */
import java.util.List;
public class fondo  extends World
{
    public Usuario w;   //Variable de tipo usuario
    public int contadorRubik=7;   //me dice cuantos rubik se generan
    public int punto=0;  //inicializa la bariable de los puntos
    private int aux=5;
    int nivel=1;
    private int numNaves=3;
    /**
     * constructor del fondo, inicializo el tamao de la ciudad
     * mando llamar al menu
     */
    public fondo()
    {    
          super(77, 45, 10); 
          this.menu();
    }
    /**
    *regreso el numero de naves existentes
    */
    public int numNaves()
    {
        return(numNaves);
    }
    /**
    *me disminuye las naves 
    */
    public void disminuyeNaves()
    {
        numNaves--;
    }
    /**
     * inicio con un fondo y con los botones
     * necesarios para la ayuda, los creditos y el juego
     */
    public void menu()
    {
      removeObjects(getObjects(null));
      setBackground("inicio.png");
      addObject(new Saludo(),113,35);
            
      Game boton1=new Game(this);
      addObject(boton1,60,15);
            
       Help boton2=new Help(this);
       addObject(boton2,50,25);
       
       Credits boton3=new Credits(this);
       addObject(boton3,40,35);
     }
     /**
      * limpia la pantalla y me muestra el escenario de la ayuda
      * con un boton de regreso al menu principal
      */
     public void ayuda()
     {
        removeObjects(getObjects(null));
        setBackground("ayuda.png");
        Back boton6=new Back(this);
        addObject(boton6,15,40);
    }
     /**
      * limpia la pantalla y me muestra el escenario de los creditos
      * con un boton de regreso al menu principal
      */
     public void Creditos()
     {
       removeObjects(getObjects(null));
        setBackground("credi.png");
        Back boton6=new Back(this);
        addObject(boton6,15,40);
     }
      /**
      * limpia la pantalla y me muestra el escenario del juego
      * me lleva a cargar el nivel
      */
     public void juego()
     {
         removeObjects(getObjects(null));
         setBackground("ciudad.png");
        checanivel(nivel);
     }
     /**
      * En este metodo genero todos los objetos que aparecen en le juego
      * asi como las paredes por las que no puede pasar el usuario, las naves
      */
    public void nivel1()
    {
     w= new Usuario(this,contadorRubik);
     addObject(new Pared(),5,30);
     addObject(new Pared(),10,30);
     addObject(new Pared(),15,30);
     addObject(new Pared(),20,30);
     addObject(new Pared(),25,30);
     addObject(new Pared(),72,20);
     addObject(new Pared(),67,20);
     addObject(new Pared(),62,20);
     addObject(new Pared(),57,20);
     addObject(new Pared(),40,30);
     addObject(new Nave(this),15,5);
     addObject(new Nave(this),35,5);
     addObject(new Nave(this),55,5);
     addObject(new Bloqueada(),72,40);
     addObject(w,5,40);
     addObject(new marcador(3,punto),8,5);
     creaRubick();
    }
     /**
      * limpia la pantalla y me muestra el escenario que muestra que gano 
      * el juego, donde eva vuela y con un boton de regreso al menu principal
      */
    public void Nivel2()
    {
        removeObjects(getObjects(null));
        setBackground("nivel2.png");
        addObject(new Saludo(),50,35);
        addObject(new Eva(),65,35);
        Back boton6=new Back(this);
        addObject(boton6,15,40);
    }
     /**
      * Genera los rubik en pososciones aleatorias
      */
     public void creaRubick()
     {
       int num=7;//Greenfoot.getRandomNumber(2)+1;
       for(int i=0;i<num;i++)
        {   
            int ancho=getHeight();//altura delmundo
            int alto=getWidth();////anchura del mundo
            int x=Greenfoot.getRandomNumber(ancho);//genera pos aleatoria
            int y=Greenfoot.getRandomNumber(alto);
            Actor rub=new Rubik();
            addObject(rub,x,y);
        }
     } 
      /**
      * limpia la pantalla y me muestra el escenario de que se ha perdido
      */
     public void perdiste()
     {
         removeObjects(getObjects(null));
         setBackground("final.gif");
         stopped();
     }
      /**
      * limpia la pantalla y me muestra el escenario de que se ha ganado
      */
     public void ganaste()
     {
         removeObjects(getObjects(null));
         setBackground("GANASTE.png");
     }
      /**
      * limpia el objeto creado para la visualizacion de las vidas
      * y me pone el nuevo marcador
      */
     public void imagenVidas(int vidas,int punto)
    { 
           removeObjects(getObjects(marcador.class));
           addObject(new marcador(vidas,punto),8,5);
    }
   /**
      * se checa si esta en la pantalla de inicio o si ya se ha ganado el jeugo
      */
     public void checanivel(int nivel)
     {
         switch(nivel)
         {
             case 1: nivel1();
             break;
             case 2: Nivel2();
             break;
         }
     }
     
  
}
